/*
   This source code has been generated with HMGGEN - Harbour Application Generator.
   Please do not remove the BEGIN and END tags and place your own code between the 
   predefined BEGIN and END tags.	
*/

#include <hmg.ch>
#include "hbclass.ch"
/* BEGIN */
/* END */

class Cases
   Method Init() constructor
   Method Find(procid, cases, refdat)
   Method Get(id, case, requestor, refdat)
   /* BEGIN */
   Method GetCurrentActivity(id, sNameActivity)
   /* END */
endclass   

Method Init() class Cases
return self

Method Find(procid, cases, refdat) class Cases
   local old := select(), obj := {}
   select 0
   use case index casea 
   /* BEGIN */
   /* END */	
   if pcount() < 3 .or. empty(refdat)
      seek str(procid, 10)
      do while .not. eof() .and. case->PROCID = procid
         aadd(cases, Case():New():Transfer()) 
         skip
      enddo
   else
      // time travelling
      set deleted off
      seek str(procid, 10)
      do while .not. eof() .and. case->PROCID = procid
         obj := SaveRec(obj)
         DbfLogRollback("CASE", case->ID, refdat)
         if case->DELETED == "N" .and. case->INGDAT <= refdat 
            aadd(cases, Case():New():Transfer()) 
         endif
         RestRec(obj)
         skip
      enddo
      set deleted on
   endif
   use
   select(old)
return cases
   
Method Get(id, case, requestor, refdat) class Cases
   local old := select(), n, obj := {}
   if requestor != "old"
      select 0
      use CASE index CASE
   endif
   seek str(id, 10)
   if found()
      if pcount() > 3 .and. !empty(refdat)
         obj := SaveRec(obj)
         DbfLogRollback("CASE", case->ID, refdat)
         case:Transfer()	
         RestRec(obj)
      else
         case:Transfer()	
      endif
   endif
   if requestor != "old" 
      if requestor != "activity"
         Activities():Find(id, case:activities, refdat)
         for n := 1 to len(case:activities)
            Activities():Get(case:activities[n]:id, case:activities[n], "case", refdat)
         next
      endif
      /* BEGIN */
      /* END */
      use
   endif  
   select(old)
return case

class Case
   data id
   data idObject
   data descrDossier
   data descrStatus
   data idProcess
   data activities
   data deleted
   data userid
   data txdate     
   data txtime
   Method Init() constructor
   Method Save(txdate, txtime, userid, ingdat)
   Method Equals(old) protected
   Method Transfer()
   Method Replace(txdate, txtime, userid) protected
   Method LogChanges(old_rec, txdate, txtime, ingdat) protected
   /* BEGIN */
   /* END */
endclass

Method Init() class Case
   self:id := 0
   self:idObject := 0
   self:descrDossier := ""
   self:descrStatus := ""
   self:idProcess := 0
   self:activities := {}
   self:deleted := "N"
   self:userid := ""
   self:txdate := ctod(" -  -    ")     
   self:txtime := ""
   /* BEGIN */
   /* END */
return self

Method Save(txdate, txtime, userid, ingdat) 
local id, newId, bChanged, old_rec, old := select(), aBrokenRules := {}
select 0
use case index case, casea
bChanged := .F.
id = self:id
if id <= 0
   // insert request
else
   // update or delete request
   old_rec = cases():Get(id, case():New(), "old")
   if found()
      // check whether content has changed
      if self:Equals(old_rec)
         // do nothing
      else 
         // check concurrent update
         if self:txdate = old_rec:txdate .and. self:txtime = old_rec:txtime
            if self:deleted = "Y"
               RecLock(1)
               case->DELETED := self:deleted
               case->USERID := userid
               case->TXDATE := txdate
               case->TXTIME := txtime
               delete
               unlock
            else
               bChanged := .T.
            endif
         else 
            MsgInfo("record has been updated by: " + old_rec:userid)
         endif
      endif
   else
      // defensive programming
      MsgInfo("record deleted by other user")
   endif
endif
if id <= 0 .or. bChanged
   // evaluation of business rules, use aBrokenRules
   /* BEGIN */
   /* END */
   // end evaluation of business rules
   if empty(aBrokenRules)
      if id <= 0	
         newId = DbfGetID("CASE")
         self:id = newId
         AddRec(1)	
         case->ID := self:id
         /* BEGIN */
         /* END */
         self:Replace(txdate, txtime, userid)
         unlock
      else
         RecLock(1)
         self:Replace(txdate, txtime, userid)
         unlock
      endif
      self:userid := userid
      self:txdate := txdate
      self:txtime := txtime
   endif
endif
use
select(old)
return(aBrokenRules)

Method Equals(old_rec) class Case
local retval := .T.
   set exact on
   if self:idObject != old_rec:idObject
      retval := .F.
   endif
   if self:descrDossier != old_rec:descrDossier
      retval := .F.
   endif
   if self:descrStatus != old_rec:descrStatus
      retval := .F.
   endif
   if self:idProcess != old_rec:idProcess
      retval := .F.
   endif
   if self:deleted != old_rec:deleted
      retval := .F.
   endif
   set exact off
return(retval)
 
Method Transfer() class Case
   self:id := case->ID 	
   self:idObject := case->REFID
   self:descrDossier := rtrim(case->DOSSIER)
   self:descrStatus := rtrim(case->STATUS)
   self:idProcess := case->PROCID
   self:deleted := case->DELETED 	
   self:userid := case->USERID 	
   self:txdate := case->TXDATE 	
   self:txtime := case->TXTIME 	
return(self)

Method Replace(txdate, txtime, userid) class Case
   case->REFID := self:idObject
   case->DOSSIER := self:descrDossier
   case->STATUS := self:descrStatus
   case->PROCID := self:idProcess
   case->DELETED := self:deleted
   case->USERID := userid
   case->TXDATE := txdate
   case->TXTIME := txtime
return(nil)

Method LogChanges(old_rec, txdate, txtime, ingdat) class Case
   if self:idObject != old_rec:idObject
      DbfLogAdd(alias(), "REFID", old_rec:id, str(old_rec:idObject), old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:descrDossier != old_rec:descrDossier
      DbfLogAdd(alias(), "DOSSIER", old_rec:id, old_rec:descrDossier, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:descrStatus != old_rec:descrStatus
      DbfLogAdd(alias(), "STATUS", old_rec:id, old_rec:descrStatus, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:idProcess != old_rec:idProcess
      DbfLogAdd(alias(), "PROCID", old_rec:id, str(old_rec:idProcess), old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:deleted != old_rec:deleted
      DbfLogAdd(alias(), "DELETED", old_rec:id, old_rec:deleted, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
return(nil)

// put here your udf's

/* BEGIN */
Method GetCurrentActivity(id, sNameActivity) class Cases
	local n, c, a := Activity()
	c := Cases():Get(id, Case():New(), "case")
	for n := 1 to len(c:activities)
      a := c:activities[n]
		if a:activityDefinition:nameActivity == sNameActivity .and. a:indicCurrent = "Y"
			exit 
		endif
	next
return(a)
/* END */
