/*
   This source code has been generated with HMGGEN - Harbour Application Generator.
   Please do not remove the BEGIN and END tags and place your own code between the 
   predefined BEGIN and END tags.	
*/

#include <hmg.ch>
#include "hbclass.ch"
/* BEGIN */
/* END */

class ActivityDefinitions
   Method Init() constructor
   Method Find(procid, activityDefinitions, refdat)
   Method Get(id, activityDefinition, requestor, refdat)
   /* BEGIN */
   Method GetIdFirstActivity(nProcId)
   /* END */
endclass   

Method Init() class ActivityDefinitions
return self

Method Find(procid, activityDefinitions, refdat) class ActivityDefinitions
   local old := select(), obj := {}
   select 0
   // use dact index dacta 
   /* BEGIN */
   use dact index dactb 
   /* END */	
   if pcount() < 3 .or. empty(refdat)
      seek str(procid, 10)
      do while .not. eof() .and. dact->PROCID = procid
         aadd(activityDefinitions, ActivityDefinition():New():Transfer()) 
         skip
      enddo
   else
      // time travelling
      set deleted off
      seek str(procid, 10)
      do while .not. eof() .and. dact->PROCID = procid
         obj := SaveRec(obj)
         DbfLogRollback("DACT", dact->ID, refdat)
         if dact->DELETED == "N" .and. dact->INGDAT <= refdat 
            aadd(activityDefinitions, ActivityDefinition():New():Transfer()) 
         endif
         RestRec(obj)
         skip
      enddo
      set deleted on
   endif
   use
   select(old)
return activityDefinitions
   
Method Get(id, activityDefinition, requestor, refdat) class ActivityDefinitions
   local old := select(), n, obj := {}
   if requestor != "old"
      select 0
      use DACT index DACT
   endif
   seek str(id, 10)
   if found()
      if pcount() > 3 .and. !empty(refdat)
         obj := SaveRec(obj)
         DbfLogRollback("DACT", dact->ID, refdat)
         activityDefinition:Transfer()	
         RestRec(obj)
      else
         activityDefinition:Transfer()	
      endif
   endif
   if requestor != "old" 
      if requestor != "process"
         Processes():Get(dact->PROCID, activityDefinition:process, "activityDefinition", refdat)
      endif
      if requestor != "nextActivity"
         NextActivities():Find(id, activityDefinition:nextActivities, refdat)
         for n := 1 to len(activityDefinition:nextActivities)
            NextActivities():Get(activityDefinition:nextActivities[n]:id, activityDefinition:nextActivities[n], "activityDefinition", refdat)
         next
      endif
      /* BEGIN */
      /* END */
      use
   endif  
   select(old)
return activityDefinition

class ActivityDefinition
   data id
   data nameActivity
   data codeRole
   data codeTeam
   data numberOfMonthsRecallterm
   data indic4Eyes
   data indicAuto
   data descrInitialStatus
   data descrActionBlock
   data process
   data nextActivities
   data numberSequence
   data deleted
   data userid
   data txdate     
   data txtime
   Method Init() constructor
   Method Save(txdate, txtime, userid, ingdat)
   Method Equals(old) protected
   Method Transfer()
   Method Replace(txdate, txtime, userid) protected
   Method LogChanges(old_rec, txdate, txtime, ingdat) protected
   /* BEGIN */
   Method SelectNextActivities(cStatusActivity, resultset) 
   /* END */
endclass

Method Init() class ActivityDefinition
   self:id := 0
   self:nameActivity := ""
   self:codeRole := 0
   self:codeTeam := ""
   self:numberOfMonthsRecallterm := 0
   self:indic4Eyes := ""
   self:indicAuto := ""
   self:descrInitialStatus := ""
   self:descrActionBlock := ""
   self:process := Process():New()
   self:nextActivities := {}
   self:numberSequence := 0
   self:deleted := "N"
   self:userid := ""
   self:txdate := ctod(" -  -    ")     
   self:txtime := ""
   /* BEGIN */
   /* END */
return self

Method Save(txdate, txtime, userid, ingdat) 
local id, newId, bChanged, old_rec, old := select(), aBrokenRules := {}
select 0
use dact index dact, dacta, dactb
bChanged := .F.
id = self:id
if id <= 0
   // insert request
else
   // update or delete request
   old_rec = activityDefinitions():Get(id, activityDefinition():New(), "old")
   if found()
      // check whether content has changed
      if self:Equals(old_rec)
         // do nothing
      else 
         // check concurrent update
         if self:txdate = old_rec:txdate .and. self:txtime = old_rec:txtime
            if self:deleted = "Y"
               RecLock(1)
               dact->DELETED := self:deleted
               dact->USERID := userid
               dact->TXDATE := txdate
               dact->TXTIME := txtime
               delete
               unlock
               self:LogChanges(old_rec, txdate, txtime, ingdat)
            else
               bChanged := .T.
            endif
         else 
            MsgInfo("record has been updated by: " + old_rec:userid)
         endif
      endif
   else
      // defensive programming
      MsgInfo("record deleted by other user")
   endif
endif
if id <= 0 .or. bChanged
   // evaluation of business rules, use aBrokenRules
   /* BEGIN */
   /* END */
   // end evaluation of business rules
   if empty(aBrokenRules)
      if id <= 0	
         newId = DbfGetID("DACT")
         self:id = newId
         AddRec(1)	
         dact->ID := self:id
         /* BEGIN */
         dact->PROCID := self:process:id
         /* update id in aPseudoId */
         

         
         private pos := ascan(aPseudoId, {|x|x[1] = id})		
         if pos > 0
            aPseudoId[pos, 2] := newId
         endif

          //MsgInfo("id dact) " + str(id))  
          //for i := 1 to len(aPseudoId)
          //  MsgInfo(str(aPseudoId[i, 1]) + " " + str(aPseudoId[i, 2]) + chr(13) + chr(10))
          //next  



         /* END */
         self:Replace(txdate, txtime, userid)
         unlock
      else
         RecLock(1)
         self:Replace(txdate, txtime, userid)
         unlock
         self:LogChanges(old_rec, txdate, txtime, ingdat)
      endif
      self:userid := userid
      self:txdate := txdate
      self:txtime := txtime
   endif
endif
use
select(old)
return(aBrokenRules)

Method Equals(old_rec) class ActivityDefinition
local retval := .T.
   set exact on
   if self:nameActivity != old_rec:nameActivity
      retval := .F.
   endif
   if self:codeRole != old_rec:codeRole
      retval := .F.
   endif
   if self:codeTeam != old_rec:codeTeam
      retval := .F.
   endif
   if self:numberOfMonthsRecallterm != old_rec:numberOfMonthsRecallterm
      retval := .F.
   endif
   if self:indic4Eyes != old_rec:indic4Eyes
      retval := .F.
   endif
   if self:indicAuto != old_rec:indicAuto
      retval := .F.
   endif
   if self:descrInitialStatus != old_rec:descrInitialStatus
      retval := .F.
   endif
   if self:descrActionBlock != old_rec:descrActionBlock
      retval := .F.
   endif
   if self:numberSequence != old_rec:numberSequence
      retval := .F.
   endif
   if self:deleted != old_rec:deleted
      retval := .F.
   endif
   set exact off
return(retval)
 
Method Transfer() class ActivityDefinition
   self:id := dact->ID 	
   self:nameActivity := rtrim(dact->ACTOMS)
   self:codeRole := dact->ROL
   self:codeTeam := rtrim(dact->BEHANDTEAM)
   self:numberOfMonthsRecallterm := dact->RAPPTERM
   self:indic4Eyes := rtrim(dact->INDIC4OGEN)
   self:indicAuto := rtrim(dact->INDICAUTO)
   self:descrInitialStatus := rtrim(dact->INITSTATUS)
   self:descrActionBlock := rtrim(dact->ACTBLOCK)
   self:numberSequence := dact->SEQNO
   self:deleted := dact->DELETED 	
   self:userid := dact->USERID 	
   self:txdate := dact->TXDATE 	
   self:txtime := dact->TXTIME 	
return(self)

Method Replace(txdate, txtime, userid) class ActivityDefinition
   dact->ACTOMS := self:nameActivity
   dact->ROL := self:codeRole
   dact->BEHANDTEAM := self:codeTeam
   dact->RAPPTERM := self:numberOfMonthsRecallterm
   dact->INDIC4OGEN := self:indic4Eyes
   dact->INDICAUTO := self:indicAuto
   dact->INITSTATUS := self:descrInitialStatus
   dact->ACTBLOCK := self:descrActionBlock
   dact->SEQNO := self:numberSequence
   dact->DELETED := self:deleted
   dact->USERID := userid
   dact->TXDATE := txdate
   dact->TXTIME := txtime
return(nil)

Method LogChanges(old_rec, txdate, txtime, ingdat) class ActivityDefinition
   if self:nameActivity != old_rec:nameActivity
      DbfLogAdd(alias(), "ACTOMS", old_rec:id, old_rec:nameActivity, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:codeRole != old_rec:codeRole
      DbfLogAdd(alias(), "ROL", old_rec:id, str(old_rec:codeRole), old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:codeTeam != old_rec:codeTeam
      DbfLogAdd(alias(), "BEHANDTEAM", old_rec:id, old_rec:codeTeam, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:numberOfMonthsRecallterm != old_rec:numberOfMonthsRecallterm
      DbfLogAdd(alias(), "RAPPTERM", old_rec:id, str(old_rec:numberOfMonthsRecallterm), old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:indic4Eyes != old_rec:indic4Eyes
      DbfLogAdd(alias(), "INDIC4OGEN", old_rec:id, old_rec:indic4Eyes, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:indicAuto != old_rec:indicAuto
      DbfLogAdd(alias(), "INDICAUTO", old_rec:id, old_rec:indicAuto, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:descrInitialStatus != old_rec:descrInitialStatus
      DbfLogAdd(alias(), "INITSTATUS", old_rec:id, old_rec:descrInitialStatus, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:descrActionBlock != old_rec:descrActionBlock
      DbfLogAdd(alias(), "ACTBLOCK", old_rec:id, old_rec:descrActionBlock, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:numberSequence != old_rec:numberSequence
      DbfLogAdd(alias(), "SEQNO", old_rec:id, str(old_rec:numberSequence), old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:deleted != old_rec:deleted
      DbfLogAdd(alias(), "DELETED", old_rec:id, old_rec:deleted, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
return(nil)

// put here your udf's

/* BEGIN */
Method GetIdFirstActivity(nProcId) class ActivityDefinitions
   local activityDefinitions, d, n, retval := 0 
   activityDefinitions := ActivityDefinitions():Find(nProcId, {})
   for n := 1 to len(activityDefinitions)
      d := activityDefinitions[n]
      if d:nameActivity == "Open case"
         retval := d:id
         exit
      endif     
   next
return(retval)

Method SelectNextActivities(cStatusActivity, resultset) class ActivityDefinition
local ruleleft, na, n
private s
for n := 1 to len(self:nextActivities)
	na := self:nextActivities[n]
   /* memotran deletes all cr/lf's and tabs */ 
	// s := rtrim(memotran(na:descrCondition, " ", " "))  
	s := "{||" + if(empty(na:descrCondition), ".T.", na:descrCondition) + "}"  
	ruleleft := &s.
	if cStatusActivity == na:descrStatus .and. eval(ruleleft)
		aadd(resultset, na:idNextActivity)
	endif 	
next
return(resultset) 
/* END */
