/*
This source code has been generated with HMGGEN - Harbour Application Generator.
Please do not remove the BEGIN and END tags and place your own code between the
predefined BEGIN and END tags.
*/

#include "hmg.ch"

declare window ORO120
/* BEGIN */
declare window OR0000
declare window ORO130
declare window ORO140
/* END */

function ORO120_OnInit()
    local n, bCondition := {||order:id = 0}
    ORO120.grid_1.DeleteAllItems
/* BEGIN */
   if OR0000.USECASE.Value = "Place order"
      ORO120.STARTDATE.Value := dtoc(date())
      ORO120.STARTTIME.Value := time()
   endif   
/* END */
    if eval(bCondition)
        ORO120.CUSTOMERNO.value := customer:numberCustomer
        ORO120.DELIVERY.value := date() + 1
    else
        ORO120.CUSTOMERNO.value := customer:numberCustomer
        ORO120.DELIVERY.value := order:dateDelivery
        for n := 1 to len(order:orderlines)
            ORO120.grid_1.AddItem({ ;
                ComboLookupDescr("BRAND", order:orderlines[n]:product:codeBrand), ;
                order:orderlines[n]:product:nameProduct, ;
                str(order:orderlines[n]:valueQuantity), ;
                order:orderlines[n]:valuePrice, ;
                order:orderlines[n]:product:id, ;
                order:orderlines[n]:id ;
            })
        next
    endif
/* BEGIN */
   ORO120.NAME.Value := customer:nameFirst + " " + customer:nameLast
   ORO120_grid_1_Refresh()
   ORO120.DELIVERY.SetFocus
/* END */
return(nil)

function ORO120_OnUpdate(order)
/* BEGIN */
/* END */
    order:dateDelivery := ORO120.DELIVERY.value
/* BEGIN */
/* END */
return(nil)

function ORO120_grid_1_OnAdd()
/* BEGIN */
   ORO120_OnUpdate(order)
   if order:dateDelivery < (date() + 1)
      MsgInfo("Deliverydate must be a date in the future")
      ORO120.DELIVERY.SetFocus
      return(nil)
   endif   
   ORO120_SaveOrder()
   orderline := Orderline():New()
   if Iswindowdefined(ORO130)
      ORO130.Release
   endif
   load window ORO130
   ORO130.Activate()
/* END */
/* BEGIN */
/* END */
return(nil)

function ORO120_grid_1_OnUpdate()
/* BEGIN */
   local aItem
   if ORO120.grid_1.Value = 0 .or. ORO120.grid_1.Value > (ORO120.grid_1.ItemCount - 3)
      MsgInfo("Please select an orderline first")
      ORO120.grid_1.SetFocus
      return(nil)
   endif
   aItem := ORO120.grid_1.Item(ORO120.grid_1.Value)
   orderline := order:orderlines[ascan(order:orderlines, {|x|x:id = aItem[6]})]
   if Iswindowdefined(ORO140)
      ORO140.Release
   endif
   load window ORO140
   ORO140.Center()
   ORO140.Activate()
/* END */
/* BEGIN */
   ruleset := {}
   factset := {}
   LoadRuleset("Orderline", ruleset)
   aadd(factset, {"_dateOrder", date()})
   orderline:valuePrice := Evaluate("_totalOrderline", ruleset, factset)
   orderline:Save(date(), time(), userprofile:userid, date())
   ORO120_grid_1_Refresh()
/* END */
return(nil)

function ORO120_grid_1_OnDelete()
/* BEGIN */
   local aItem
   if ORO120.grid_1.Value = 0 .or. ORO120.grid_1.Value > (ORO120.grid_1.ItemCount - 3)
      MsgInfo("Please select an orderline first")
      ORO120.grid_1.SetFocus
      return(nil)
   endif
   aItem := ORO120.grid_1.Item(ORO120.grid_1.Value)
   orderline := order:orderlines[ascan(order:orderlines, {|x|x:id = aItem[6]})]
   orderline:deleted := "Y"   
   orderline:Save(date(), time(), userprofile:userid, date())
   ORO120_grid_1_Refresh()
/* END */
/* BEGIN */
/* END */
return(nil)

function ORO120_OnCancel()
/* BEGIN */
/* END */
   ORO120_OnInit()
/* BEGIN */
/* END */
return(nil)

function ORO120_OnApply()
/* BEGIN */
/* END */
   ORO120_OnUpdate(order)
/* BEGIN */
   if order:dateDelivery < (date() + 1)
      MsgInfo("Deliverydate must be a date in the future")
      ORO120.DELIVERY.SetFocus
      return(nil)
   endif 
   ORO120_SaveOrder() 
   /* ORO120.Release triggers ORO120_OnClose() */
   ORO120.Release
/* END */
return(nil)

function ORO120_OnClose()
/* BEGIN */
   local aItem
   if OR0000.USECASE.Value = "Place order"
      if order:id > 0
         OR0000.grid_1_2.AddItem({order:numberOrder, dtoc(order:txdate), dtoc(order:dateDelivery), GetOrderGrandTotal(), order:id})
      endif   
   else
      aItem := OR0000.grid_1_2.Item(OR0000.grid_1_2.Value)
      aItem[4] := GetOrderGrandTotal()
      OR0000.grid_1_2.Item(OR0000.grid_1_2.Value) := aItem
   endif   
/* END */
return(.T.)

/* BEGIN */
function ORO120_grid_1_Refresh()
   local n, orderline, nTotal, ruleset, factset
   ORO120.grid_1.DeleteAllItems
   if order:id > 0
      for n := 1 to len(order:orderlines)
         orderline := order:orderlines[n]
         if orderline:deleted = "N"
            ORO120.grid_1.AddItem({ ;
               ComboLookupDescr("BRAND", orderline:product:codeBrand), ;
               orderline:product:nameProduct, ;
               str(orderline:valueQuantity), ;
               orderline:valuePrice, ;
               orderline:product:id, ;
               orderline:id ;
            })
         endif   
      next
      ruleset := {}
      factset := {}
      LoadRuleset("Order", ruleset)
      aadd(factset, {"_dateOrder", order:txdate})
      AddFact(factset, {"_subtotalOrder", Evaluate("_subtotalOrder", ruleset, factset)})
      AddFact(factset, {"_shippingcost", Evaluate("_shippingcost", ruleset, factset)})
      nTotal := Evaluate("_totalOrder", ruleset, factset)
      ORO120.grid_1.AddItem({"Sub total",,,GetFact(factset, "_subtotalOrder"),0,0})
      ORO120.grid_1.AddItem({"Shipping cost",,,GetFact(factset, "_shippingcost"),0,0})
      ORO120.grid_1.AddItem({"Total",,,nTotal,0,0})
   endif
return(nil)

function ORO120_SaveOrder()
   local nId := order:id, aItem
   if order:id = 0
      order:numberOrder := val(substr(dtos(date()), 4) + strzero(Orders():GetLatestSeqno(date()) + 1, 3))
      order:customer:id := customer:id
      order:descrStatus := "Placed"
   endif   
   order:Save(date(), time(), userprofile:userid, date())
   if OR0000.USECASE.Value = "Place order"
      if nId = 0
         nCaseId := WfmMakeCase("Process order", order:id, "", ctod(ORO120.STARTDATE.Value), ORO120.STARTTIME.Value)
         /* note that 5 params are passed, only provide param 6 when the next activity must be performed automatically */ 
         WfmUpdateStatus("Process order", "Place order", nCaseId, "Order placed", "", "continue")
      endif   
   endif   
return(nil)

function GetOrderGrandTotal()
   local ruleset, factset, nGrandTotal
   ruleset := {}
   factset := {}
   LoadRuleset("Order", ruleset)
   aadd(factset, {"_dateOrder", order:txdate})
   nGrandTotal := Evaluate("_totalOrder", ruleset, factset)
return(nGrandTotal)

function GetOrderTotal()
   local ruleset, factset, n, oOrderline := orderline
   ruleset := {}
   factset := {}
   LoadRuleset("Orderline", ruleset)
   aadd(factset, {"_dateOrder", order:txdate})
   aadd(factset, {"_subtotalOrder", 0})
   for n := 1 to len(order:orderlines)
      orderline := order:orderlines[n]
      if orderline:deleted = "N"
         Evaluate("_subtotalOrder", ruleset, factset)
      endif   
   next
   orderline := oOrderline
return(GetFact(factset, "_subtotalOrder"))
/* END */
