/*
This source code has been generated with HMGGEN - Harbour Application Generator.
Please do not remove the BEGIN and END tags and place your own code between the
predefined BEGIN and END tags.
*/

#include "hmg.ch"

declare window ORO130
/* BEGIN */
declare window ORO120
declare window ORO140
/* END */

function ORO130_OnInit()
    local n, aObjects := {}, oProduct, bCondition := {||product:id = 0}
    ORO130.grid_1.DeleteAllItems
/* BEGIN */
   /* After regeneration of this form please reposition form to row 160 and col 220 */ 
   /* the next statement is a little tric */
   product := Product():New()
   aObjects := Products():QueryOnDepartment("Milk")
/* END */
    ComboLoadItems("DEPARTMENT", "DEPARTMENT", "ORO130")
    if eval(bCondition)
        ORO130.DEPARTMENT.value := ComboLookupDefault("DEPARTMENT", "DEPARTMENT", "ORO130")
    else
        ORO130.DEPARTMENT.value := ComboLookupValue("DEPARTMENT", "DEPARTMENT", "ORO130", product:codeDepartment)
        for n := 1 to len(aObjects)
            oProduct := aObjects[n]
            ORO130.grid_1.AddItem({ ;
                ComboLookupDescr("CATEGORY", oProduct:codeCategory), ;
                ComboLookupDescr("BRAND", oProduct:codeBrand), ;
                oProduct:nameProduct, ;
                ComboLookupDescr("PACKUNIT", oProduct:codePackagingunit), ;
                oProduct:valuePrice, ;
                oProduct:id ;
            })
        next
    endif
/* BEGIN */
/*
   copy generated code to LoadProducts()
*/
   LoadProducts("Milk") 
/* END */
return(nil)

function ORO130_OnUpdate(product)
/* BEGIN */
/* END */
    product:codeDepartment := ComboGetCode("DEPARTMENT", "DEPARTMENT", "ORO130")
    product:codeCategory := ORO130.CATEGORY.value
    product:codeBrand := ORO130.BRAND.value
    product:nameProduct := ORO130.PRODNAME.value
    product:codePackagingunit := ORO130.PACKUNIT.value
    product:valuePrice := ORO130.PRICE.value
/* BEGIN */
/* END */
return(nil)

function ORO130_OnAdd()
/* BEGIN */
   local aItem, ruleset, factset
   if ORO130.grid_1.Value = 0
      MsgInfo("Please select a product first")
      ORO130.grid_1.SetFocus
      return(nil)
   endif
   if Iswindowdefined(ORO140)
      ORO140.Release
   endif
   load window ORO140
   ORO140.Center()
   ORO140.Activate()
/* END */
/* BEGIN */
   aItem := ORO130.grid_1.Item(ORO130.grid_1.Value)
   orderline:order:id := order:id
   orderline:valueQuantity := ORO130.QUANTITY.Value
   orderline:product := Products():get(aItem[6], orderline:product, "product")
   ruleset := {}
   factset := {}
   LoadRuleset("Orderline", ruleset)
   aadd(factset, {"_dateOrder", date()})
   orderline:valuePrice := Evaluate("_totalOrderline", ruleset, factset)
   orderline:Save(date(), time(), userprofile:userid, date())
   aadd(order:orderlines, orderline)
   orderline := Orderline():New()
   ORO120_grid_1_Refresh()
   ORO130.grid_1.Value := 0 /* doesn't work */
   ORO130.grid_1.SetFocus
/* END */
return(nil)

function ORO130_DEPARTMENT_OnChange()
/* BEGIN */
   LoadProducts(ComboGetCode("DEPARTMENT", "DEPARTMENT", "ORO130")) 
/* END */
return(nil)

function ORO130_OnClose()
/* BEGIN */
/* END */
return(.T.)

/* BEGIN */
function LoadProducts(cDepartment) 
   local aObjects, oProducts
   ORO130.grid_1.DeleteAllItems
   aObjects := Products():QueryOnDepartment(cDepartment)
     for n := 1 to len(aObjects)
         oProduct := aObjects[n]
         ORO130.grid_1.AddItem({ ;
             ComboLookupDescr("CATEGORY", oProduct:codeCategory), ;
             ComboLookupDescr("BRAND", oProduct:codeBrand), ;
             oProduct:nameProduct, ;
             ComboLookupDescr("PACKUNIT", oProduct:codePackagingunit), ;
             oProduct:valuePrice, ;
             oProduct:id ;
         })
     next
return(nil)
/* END */
