/*
This source code has been generated with HMGGEN - Harbour Application Generator.
Please do not remove the BEGIN and END tags and place your own code between the
predefined BEGIN and END tags.
*/

#include "hmg.ch"

declare window ORP110
/* BEGIN */
declare window OR0000
declare window ORP120
/* END */

function ORP110_OnInit()
    local n, aObjects := {}, oProduct
    ORP110.grid_1.DeleteAllItems
/* BEGIN */
   aObjects := Products():QueryOnAll()
/* END */
    for n := 1 to len(aObjects)
        oProduct := aObjects[n]
        ORP110.grid_1.AddItem({ ;
            ComboLookupDescr("DEPARTMENT", oProduct:codeDepartment), ;
            ComboLookupDescr("CATEGORY", oProduct:codeCategory), ;
            ComboLookupDescr("BRAND", oProduct:codeBrand), ;
            oProduct:nameProduct, ;
            ComboLookupDescr("PACKUNIT", oProduct:codePackagingunit), ;
            oProduct:valuePrice, ;
            oProduct:id ;
        })
    next
/* BEGIN */
   if OR0000.USECASE.Value == "Update assortment"
      ORP110.Add.Visible := .T.
      ORP110.Delete.Visible := .T.
      ORP110.Select.Visible := .F.
   else
      ORP110.Add.Visible := .F.
      ORP110.Delete.Visible := .F.
      ORP110.Select.Visible := .T.
   endif   
/* END */
return(nil)

function ORP110_OnSelect()
/* BEGIN */
   local aItem
   if ORP110.grid_1.Value = 0
      MsgInfo("Please select aproduct first")
      ORP110.grid_1.SetFocus
      return(nil)
   endif
   aItem := ORP110.grid_1.Item(ORP110.grid_1.Value)
   product := Products():Get(aItem[7], Product():New(), "product")
   load window ORP120
   ORP120.Activate()
/* END */
/* BEGIN */
/* END */
return(nil)

function ORP110_OnAdd()
/* BEGIN */
   OR0000.USECASE.Value := "Add new product"
   product := Product():New()
   if IsWindowDefined(ORP120)
      ORP120.Release
   endif   
   load window ORP120
   ORP120.Activate()
/* END */
/* BEGIN */
/* END */
return(nil)

function ORP110_OnDelete()
/* BEGIN */
   local aItem
   if ORP110.grid_1.Value = 0
      MsgInfo("Please select aproduct first")
      ORP110.grid_1.SetFocus
      return(nil)
   endif
   aItem := ORP110.grid_1.Item(ORP110.grid_1.Value)
   if Orderlines():IsProductInUse(aItem[7])
      MsgInfo("Product is in use")
      ORP110.grid_1.SetFocus
      return(nil)
   endif
   if MsgYesNo("are you sure ?")
      product := Products():Get(aItem[7], Product():New(), "product")
      product:deleted := "Y"
      product:Save(date(), time(), userprofile:userid, date())
      ORP110.grid_1.DeleteItem(ORP110.grid_1.Value)
   endif
/* END */
/* BEGIN */
/* END */
return(nil)

function ORP110_OnClose()
/* BEGIN */
/* END */
return(.T.)

/* BEGIN */
/* END */
