/*
This source code has been generated with HMGGEN - Harbour Application Generator.
Please do not remove the BEGIN and END tags and place your own code between the
predefined BEGIN and END tags.
*/

#include "hmg.ch"

declare window ORP120
/* BEGIN */
declare window OR0000
declare window ORP122
/* END */

function ORP120_OnInit()
    local bCondition := {||product:id = 0}
/* BEGIN */
   local oPricechange
   ORP120.TXDATE.Value := dtoc(date())
   ORP120.TXTIME.Value := time()
   if OR0000.USECASE.Value == "Add new product"
   elseif OR0000.USECASE.Value == "Approve new product"
      product := Product():New()
      product := xml2obj(WfmLookupDossier(WfmGetCurrentCaseId()))
      ORP120.PRICE.Enabled := .F.
      ORP120.STARTDATE.Enabled := .F.
      ORP120.CLOSE_2.Visible := .T.
      ORP120.CANCEL.Visible := .F.
      ORP120.APPLY.Visible := .F.
   elseif OR0000.USECASE.Value == "Adjust new product"
      product := Product():New()
      product := xml2obj(WfmLookupDossier(WfmGetCurrentCaseId()))
   elseif OR0000.USECASE.Value == "Change price"
   elseif OR0000.USECASE.Value == "Approve pricechange"
      oPricechange := Pricechange():New()
      oPricechange := xml2obj(WfmLookupDossier(WfmGetCurrentCaseId()))
      product := Products():Get(nIdentity, Product(), "product")
      ORP120.PRICE.Enabled := .F.
      ORP120.STARTDATE.Enabled := .F.
      ORP120.CLOSE_2.Visible := .T.
      ORP120.CANCEL.Visible := .F.
      ORP120.APPLY.Visible := .F.
   elseif OR0000.USECASE.Value == "Adjust pricechange"
      oPricechange := Pricechange():New()
      oPricechange := xml2obj(WfmLookupDossier(WfmGetCurrentCaseId()))
      product := Products():Get(nIdentity, Product(), "product")
   endif   
/* END */
    ComboLoadItems("DEPARTMENT", "DEPARTMENT", "ORP120")
    ComboLoadItemsEx("CATEGORY", "CATEGORY", "ORP120", "Milk")
    ComboLoadItemsEx("BRAND", "BRAND", "ORP120", "Milk")
    ComboLoadItemsEx("PACKUNIT", "PACKUNIT", "ORP120", "Milk")
    if eval(bCondition)
        ORP120.DEPARTMENT.value := ComboLookupDefault("DEPARTMENT", "DEPARTMENT", "ORP120")
        ORP120.CATEGORY.value := ComboLookupDefault("CATEGORY", "CATEGORY", "ORP120")
        ORP120.BRAND.value := ComboLookupDefault("BRAND", "BRAND", "ORP120")
        ORP120.PACKUNIT.value := ComboLookupDefault("PACKUNIT", "PACKUNIT", "ORP120")
        ORP120.PRODCODE.value := ""
        ORP120.PRODNAME.value := ""
        ORP120.PRICE.value := 0
    else
        ORP120.DEPARTMENT.value := ComboLookupValue("DEPARTMENT", "DEPARTMENT", "ORP120", product:codeDepartment)
        ORP120.CATEGORY.value := ComboLookupValue("CATEGORY", "CATEGORY", "ORP120", product:codeCategory)
        ORP120.BRAND.value := ComboLookupValue("BRAND", "BRAND", "ORP120", product:codeBrand)
        ORP120.PACKUNIT.value := ComboLookupValue("PACKUNIT", "PACKUNIT", "ORP120", product:codePackagingunit)
        ORP120.PRODCODE.value := product:codeProductExternal
        ORP120.PRODNAME.value := product:nameProduct
        ORP120.PRICE.value := product:valuePrice
    endif
/* BEGIN */
   if OR0000.USECASE.Value == "Add new product" 
      ORP120.DEPARTMENT.Enabled := .T.
      ORP120.CATEGORY.Enabled := .T.
      ORP120.BRAND.Enabled := .T.
      ORP120.PRODCODE.Enabled := .T.
      ORP120.PRODNAME.Enabled := .T.
      ORP120.PACKUNIT.Enabled := .T.
   elseif OR0000.USECASE.Value == "Adjust new product"
      ORP120.DEPARTMENT.Enabled := .T.
      ORP120.CATEGORY.Enabled := .T.
      ORP120.BRAND.Enabled := .T.
      ORP120.PRODCODE.Enabled := .T.
      ORP120.PRODNAME.Enabled := .T.
      ORP120.PACKUNIT.Enabled := .T.
   elseif OR0000.USECASE.Value == "Change price"
      ORP120.DEPARTMENT.Enabled := .F.
      ORP120.CATEGORY.Enabled := .F.
      ORP120.BRAND.Enabled := .F.
      ORP120.PRODCODE.Enabled := .F.
      ORP120.PRODNAME.Enabled := .F.
      ORP120.PACKUNIT.Enabled := .F.
   elseif OR0000.USECASE.Value == "Adjust pricechange"
      ORP120.DEPARTMENT.Enabled := .F.
      ORP120.CATEGORY.Enabled := .F.
      ORP120.BRAND.Enabled := .F.
      ORP120.PRODCODE.Enabled := .F.
      ORP120.PRODNAME.Enabled := .F.
      ORP120.PACKUNIT.Enabled := .F.
   else   
      ORP120.DEPARTMENT.Enabled := .F.
      ORP120.CATEGORY.Enabled := .F.
      ORP120.BRAND.Enabled := .F.
      ORP120.PRODCODE.Enabled := .F.
      ORP120.PRODNAME.Enabled := .F.
      ORP120.PACKUNIT.Enabled := .F.
   endif   
   /* overrule standard behavior */
   if OR0000.USECASE.Value == "Add new product" 
      ORP120.STARTDATE.Value := date() + 1
   elseif OR0000.USECASE.Value == "Approve new product" 
      ORP120.PRODCODE.value := product:codeProductExternal
      ORP120.PRODNAME.value := product:nameProduct
      ORP120.PRICE.value := product:valuePrice
      ORP120.STARTDATE.Value := product:txdate
   elseif OR0000.USECASE.Value == "Adjust new product"
      ORP120.PRODCODE.value := product:codeProductExternal
      ORP120.PRODNAME.value := product:nameProduct
      ORP120.PRICE.value := product:valuePrice
      ORP120.STARTDATE.Value := product:txdate
   elseif OR0000.USECASE.Value == "Change price"
      ORP120.STARTDATE.Value := date() + 1
   elseif OR0000.USECASE.Value == "Approve pricechange"
      ORP120.PRICE.value := oPricechange:producttypes[1]:price
      ORP120.STARTDATE.Value := oPricechange:startdate
   elseif OR0000.USECASE.Value == "Adjust pricechange"
      ORP120.PRICE.value := oPricechange:producttypes[1]:price
      ORP120.STARTDATE.Value := oPricechange:startdate
   endif   
/* END */
return(nil)

function ORP120_OnUpdate(product)
/* BEGIN */
/* END */
    product:codeDepartment := ComboGetCode("DEPARTMENT", "DEPARTMENT", "ORP120")
    product:codeCategory := ComboGetCode("CATEGORY", "CATEGORY", "ORP120")
    product:codeBrand := ComboGetCode("BRAND", "BRAND", "ORP120")
    product:codePackagingunit := ComboGetCode("PACKUNIT", "PACKUNIT", "ORP120")
    product:codeProductExternal := ORP120.PRODCODE.value
    product:nameProduct := ORP120.PRODNAME.value
    product:valuePrice := ORP120.PRICE.value
/* BEGIN */
/* END */
return(nil)

function ORP120_OnHistory()
/* BEGIN */
   if IsWindowDefined(ORP122)
      ORP122.Release
   endif   
   load window ORP122
   ORP122.Activate
/* END */
/* BEGIN */
/* END */
return(nil)

function ORP120_OnCancel()
/* BEGIN */
/* END */
   ORP120_OnInit()
/* BEGIN */
/* END */
return(nil)

function ORP120_OnApply()
/* BEGIN */
   local oPricechange, oProducttype, cDossier
/* END */
   ORP120_OnUpdate(product)
/* BEGIN */
   if OR0000.USECASE.Value == "Add new product"
      product:txdate := ORP120.STARTDATE.Value
      cDossier := ""		
      obj2xml(product, @cDossier)
      if IsWindowDefined(HGW010)
         nCaseId := WfmGetCurrentCaseId()
         WfmUpdateDossier(nCaseId, cDossier)
      else
         nCaseId := WfmMakeCase("Update assortment", product:id, cDossier, ctod(ORP120.TXDATE.Value), ORP120.TXTIME.Value)
      endif   
      /* note that 5 params are passed, only provide param 6 when the next activity must be performed automatically */ 
      WfmUpdateStatus("Update assortment", "Add new product", nCaseId, "New product added", "", "continue")   
   elseif OR0000.USECASE.Value == "Adjust new product"
      product:txdate := ORP120.STARTDATE.Value
      cDossier := ""		
      obj2xml(product, @cDossier)
      if IsWindowDefined(HGW010)
         nCaseId := WfmGetCurrentCaseId()
         WfmUpdateDossier(nCaseId, cDossier)
      else
         nCaseId := WfmMakeCase("Update assortment", product:id, cDossier, ctod(ORP120.TXDATE.Value), ORP120.TXTIME.Value)
      endif   
      /* note that 5 params are passed, only provide param 6 when the next activity must be performed automatically */ 
      WfmUpdateStatus("Update assortment", "Adjust new product", nCaseId, "New product adjusted", "", "continue")   
   elseif OR0000.USECASE.Value == "Change price"
      oPricechange := Pricechange():New()
      oPriceChange:startdate := ORP120.STARTDATE.Value
      oProducttype := Producttype():New()
      oProducttype:productcode := product:codeProductExternal
      oProducttype:price := product:valuePrice
      aadd(oPricechange:producttypes, oProducttype)
      cDossier := ""		
      obj2xml(oPricechange, @cDossier)
      nCaseId := WfmMakeCase("Change price", product:id, cDossier, ctod(ORP120.TXDATE.Value), ORP120.TXTIME.Value)
      /* note that 5 params are passed, only provide param 6 when the next activity must be performed automatically */ 
      WfmUpdateStatus("Change price", "Change price", nCaseId, "Price changed", "", "continue")   
   elseif OR0000.USECASE.Value == "Adjust pricechange"
      oPricechange := Pricechange():New()
      oPriceChange:startdate := ORP120.STARTDATE.Value
      oProducttype := Producttype():New()
      oProducttype:productcode := product:codeProductExternal
      oProducttype:price := product:valuePrice
      aadd(oPricechange:producttypes, oProducttype)
      cDossier := ""		
      obj2xml(oPricechange, @cDossier)
      nCaseId := WfmGetCurrentCaseId()
      WfmUpdateDossier(nCaseId, cDossier)
      /* note that 5 params are passed, only provide param 6 when the next activity must be performed automatically */ 
      WfmUpdateStatus("Change price", "Adjust pricechange", nCaseId, "Pricechange adjusted", "", "continue")   
   endif
   ORP120.Release
/* END */
return(nil)

function ORP120_OnClose_2()
/* BEGIN */
   ORP120.Release
/* END */
/* BEGIN */
/* END */
return(nil)

function ORP120_DEPARTMENT_OnChange()
/* BEGIN */
   local cRefCode := ComboGetCode("DEPARTMENT", "DEPARTMENT", "ORP120")
   ComboLoadItemsEx("CATEGORY", "CATEGORY", "ORP120", cRefCode)
   ORP120.category.Value := ComboLookupDefault("CATEGORY", "CATEGORY", "ORP120", cRefCode)
   ComboLoadItemsEx("BRAND", "BRAND", "ORP120", cRefCode)
   ORP120.brand.Value := ComboLookupDefault("BRAND", "BRAND", "ORP120", cRefCode)
   ComboLoadItemsEx("PACKUNIT", "PACKUNIT", "ORP120", cRefCode)
   ORP120.packunit.Value := ComboLookupDefault("PACKUNIT", "PACKUNIT", "ORP120", cRefCode)
/* END */
return(nil)

function ORP120_OnClose()
/* BEGIN */
/* END */
return(.T.)

/* BEGIN */
/* END */
