/*
   This source code has been generated with HMGGEN - Harbour Application Generator.
   Please do not remove the BEGIN and END tags and place your own code between the 
   predefined BEGIN and END tags.	
*/

#include <hmg.ch>
#include "hbclass.ch"
/* BEGIN */
/* END */

class NextActivities
   Method Init() constructor
   Method Find(dactid, nextActivities, refdat)
   Method Get(id, nextActivity, requestor, refdat)
   /* BEGIN */
   /* END */
endclass   

Method Init() class NextActivities
return self

Method Find(dactid, nextActivities, refdat) class NextActivities
   local old := select(), obj := {}
   select 0
   use nact index nacta 
   /* BEGIN */
   /* END */	
   if pcount() < 3 .or. empty(refdat)
      seek str(dactid, 10)
      do while .not. eof() .and. nact->DACTID = dactid
         aadd(nextActivities, NextActivity():New():Transfer()) 
         skip
      enddo
   else
      // time travelling
      set deleted off
      seek str(dactid, 10)
      do while .not. eof() .and. nact->DACTID = dactid
         obj := SaveRec(obj)
         DbfLogRollback("NACT", nact->ID, refdat)
         if nact->DELETED == "N" .and. nact->INGDAT <= refdat 
            aadd(nextActivities, NextActivity():New():Transfer()) 
         endif
         RestRec(obj)
         skip
      enddo
      set deleted on
   endif
   use
   select(old)
return nextActivities
   
Method Get(id, nextActivity, requestor, refdat) class NextActivities
   local old := select(), n, obj := {}
   if requestor != "old"
      select 0
      use NACT index NACT
   endif
   seek str(id, 10)
   if found()
      if pcount() > 3 .and. !empty(refdat)
         obj := SaveRec(obj)
         DbfLogRollback("NACT", nact->ID, refdat)
         nextActivity:Transfer()	
         RestRec(obj)
      else
         nextActivity:Transfer()	
      endif
   endif
   if requestor != "old" 
      if requestor != "activityDefinition"
         ActivityDefinitions():Get(nact->DACTID, nextActivity:activityDefinition, "nextActivity", refdat)
      endif
      /* BEGIN */
      /* END */
      use
   endif  
   select(old)
return nextActivity

class NextActivity
   data id
   data descrStatus
   data descrCondition
   data idNextActivity
   data activityDefinition
   data deleted
   data userid
   data txdate     
   data txtime
   Method Init() constructor
   Method Save(txdate, txtime, userid, ingdat)
   Method Equals(old) protected
   Method Transfer()
   Method Replace(txdate, txtime, userid) protected
   Method LogChanges(old_rec, txdate, txtime, ingdat) protected
   /* BEGIN */
   /* END */
endclass

Method Init() class NextActivity
   self:id := 0
   self:descrStatus := ""
   self:descrCondition := ""
   self:idNextActivity := 0
   self:activityDefinition := ActivityDefinition():New()
   self:deleted := "N"
   self:userid := ""
   self:txdate := ctod(" -  -    ")     
   self:txtime := ""
   /* BEGIN */
   /* END */
return self

Method Save(txdate, txtime, userid, ingdat) 
local id, newId, bChanged, old_rec, old := select(), aBrokenRules := {}
select 0
use nact index nact, nacta
bChanged := .F.
id = self:id
if id <= 0
   // insert request
else
   // update or delete request
   old_rec = nextActivities():Get(id, nextActivity():New(), "old")
   if found()
      // check whether content has changed
      if self:Equals(old_rec)
         // do nothing
      else 
         // check concurrent update
         if self:txdate = old_rec:txdate .and. self:txtime = old_rec:txtime
            if self:deleted = "Y"
               RecLock(1)
               nact->DELETED := self:deleted
               nact->USERID := userid
               nact->TXDATE := txdate
               nact->TXTIME := txtime
               delete
               unlock
               self:LogChanges(old_rec, txdate, txtime, ingdat)
            else
               bChanged := .T.
            endif
         else 
            MsgInfo("record has been updated by: " + old_rec:userid)
         endif
      endif
   else
      // defensive programming
      MsgInfo("record deleted by other user")
   endif
endif
if id <= 0 .or. bChanged
   // evaluation of business rules, use aBrokenRules
   /* BEGIN */
   /* END */
   // end evaluation of business rules
   if empty(aBrokenRules)
      if id <= 0	
         newId = DbfGetID("NACT")
         self:id = newId
         AddRec(1)	
         nact->ID := self:id
         /* BEGIN */
         nact->DACTID := self:activityDefinition:id
         /* update id in aPseudoId */
         private pos := ascan(aPseudoId, {|x|x[1] = id})		
         if pos > 0
            aPseudoId[pos, 2] := newId
         endif
          /* replace pseudoid */
            
          //MsgInfo("idNextActivity " + str(self:idNextActivity))  
          //for i := 1 to len(aPseudoId)
          //  MsgInfo(str(aPseudoId[i, 1]) + " " + str(aPseudoId[i, 2]) + chr(13) + chr(10))
          //next  

         if self:idNextActivity < 0
            pos := ascan(aPseudoId, {|x|x[1] = self:idNextActivity})		
            if pos > 0
               self:idNextActivity := aPseudoId[pos, 2]
            endif
         endif
         /* END */
         self:Replace(txdate, txtime, userid)
         unlock
      else
         RecLock(1)
         self:Replace(txdate, txtime, userid)
         unlock
         self:LogChanges(old_rec, txdate, txtime, ingdat)
      endif
      self:userid := userid
      self:txdate := txdate
      self:txtime := txtime
   endif
endif
use
select(old)
return(aBrokenRules)

Method Equals(old_rec) class NextActivity
local retval := .T.
   set exact on
   if self:descrStatus != old_rec:descrStatus
      retval := .F.
   endif
   if self:descrCondition != old_rec:descrCondition
      retval := .F.
   endif
   if self:idNextActivity != old_rec:idNextActivity
      retval := .F.
   endif
   if self:deleted != old_rec:deleted
      retval := .F.
   endif
   set exact off
return(retval)
 
Method Transfer() class NextActivity
   self:id := nact->ID 	
   self:descrStatus := rtrim(nact->STATUS)
   self:descrCondition := rtrim(nact->RULE)
   self:idNextActivity := nact->NEXTACT
   self:deleted := nact->DELETED 	
   self:userid := nact->USERID 	
   self:txdate := nact->TXDATE 	
   self:txtime := nact->TXTIME 	
return(self)

Method Replace(txdate, txtime, userid) class NextActivity
   nact->STATUS := self:descrStatus
   nact->RULE := self:descrCondition
   nact->NEXTACT := self:idNextActivity
   nact->DELETED := self:deleted
   nact->USERID := userid
   nact->TXDATE := txdate
   nact->TXTIME := txtime
return(nil)

Method LogChanges(old_rec, txdate, txtime, ingdat) class NextActivity
   if self:descrStatus != old_rec:descrStatus
      DbfLogAdd(alias(), "STATUS", old_rec:id, old_rec:descrStatus, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:descrCondition != old_rec:descrCondition
      DbfLogAdd(alias(), "RULE", old_rec:id, old_rec:descrCondition, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:idNextActivity != old_rec:idNextActivity
      DbfLogAdd(alias(), "NEXTACT", old_rec:id, str(old_rec:idNextActivity), old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:deleted != old_rec:deleted
      DbfLogAdd(alias(), "DELETED", old_rec:id, old_rec:deleted, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
return(nil)

// put here your udf's

/* BEGIN */
/* END */
