/*
   This source code has been generated with HMGGEN - Harbour Application Generator.
   Please do not remove the BEGIN and END tags and place your own code between the 
   predefined BEGIN and END tags.	
*/

#include <hmg.ch>
#include "hbclass.ch"
/* BEGIN */
/* END */

class Processes
   Method Init() constructor
   Method Find(applid, processes, refdat)
   Method Get(id, process, requestor, refdat)
   /* BEGIN */
   Method GetProcessId(sProcoms) 
   /* END */
endclass   

Method Init() class Processes
return self

Method Find(applid, processes, refdat) class Processes
   local old := select(), obj := {}
   select 0
   use proc index proca 
   /* BEGIN */
   /* END */	
   if pcount() < 3 .or. empty(refdat)
      seek str(applid, 10)
      do while .not. eof() .and. proc->APPLID = applid
         aadd(processes, Process():New():Transfer()) 
         skip
      enddo
   else
      // time travelling
      set deleted off
      seek str(applid, 10)
      do while .not. eof() .and. proc->APPLID = applid
         obj := SaveRec(obj)
         DbfLogRollback("PROC", proc->ID, refdat)
         if proc->DELETED == "N" .and. proc->INGDAT <= refdat 
            aadd(processes, Process():New():Transfer()) 
         endif
         RestRec(obj)
         skip
      enddo
      set deleted on
   endif
   use
   select(old)
return processes
   
Method Get(id, process, requestor, refdat) class Processes
   local old := select(), n, obj := {}
   if requestor != "old"
      select 0
      use PROC index PROC
   endif
   seek str(id, 10)
   if found()
      if pcount() > 3 .and. !empty(refdat)
         obj := SaveRec(obj)
         DbfLogRollback("PROC", proc->ID, refdat)
         process:Transfer()	
         RestRec(obj)
      else
         process:Transfer()	
      endif
   endif
   if requestor != "old" 
      if requestor != "activityDefinition"
         ActivityDefinitions():Find(id, process:activityDefinitions, refdat)
         for n := 1 to len(process:activityDefinitions)
            ActivityDefinitions():Get(process:activityDefinitions[n]:id, process:activityDefinitions[n], "process", refdat)
         next
      endif
      /* BEGIN */
      /* END */
      use
   endif  
   select(old)
return process

class Process
   data id
   data nameProcess
   data codeProcess
   data idApplication
   data activityDefinitions
   data deleted
   data userid
   data txdate     
   data txtime
   Method Init() constructor
   Method Save(txdate, txtime, userid, ingdat)
   Method Equals(old) protected
   Method Transfer()
   Method Replace(txdate, txtime, userid) protected
   Method LogChanges(old_rec, txdate, txtime, ingdat) protected
   /* BEGIN */
   /* END */
endclass

Method Init() class Process
   self:id := 0
   self:nameProcess := ""
   self:codeProcess := ""
   self:idApplication := 0
   self:activityDefinitions := {}
   self:deleted := "N"
   self:userid := ""
   self:txdate := ctod(" -  -    ")     
   self:txtime := ""
   /* BEGIN */
   /* END */
return self

Method Save(txdate, txtime, userid, ingdat) 
local id, newId, bChanged, old_rec, old := select(), aBrokenRules := {}
select 0
use proc index proc, proca
bChanged := .F.
id = self:id
if id <= 0
   // insert request
else
   // update or delete request
   old_rec = processes():Get(id, process():New(), "old")
   if found()
      // check whether content has changed
      if self:Equals(old_rec)
         // do nothing
      else 
         // check concurrent update
         if self:txdate = old_rec:txdate .and. self:txtime = old_rec:txtime
            if self:deleted = "Y"
               RecLock(1)
               proc->DELETED := self:deleted
               proc->USERID := userid
               proc->TXDATE := txdate
               proc->TXTIME := txtime
               delete
               unlock
               self:LogChanges(old_rec, txdate, txtime, ingdat)
            else
               bChanged := .T.
            endif
         else 
            MsgInfo("record has been updated by: " + old_rec:userid)
         endif
      endif
   else
      // defensive programming
      MsgInfo("record deleted by other user")
   endif
endif
if id <= 0 .or. bChanged
   // evaluation of business rules, use aBrokenRules
   /* BEGIN */
   /* END */
   // end evaluation of business rules
   if empty(aBrokenRules)
      if id <= 0	
         newId = DbfGetID("PROC")
         self:id = newId
         AddRec(1)	
         proc->ID := self:id
         /* BEGIN */
         /* update id in aPseudoId */
         private pos := ascan(aPseudoId, {|x|x[1] = id})		
         if pos > 0
            aPseudoId[pos, 2] := newId
         endif
         /* END */
         self:Replace(txdate, txtime, userid)
         unlock
      else
         RecLock(1)
         self:Replace(txdate, txtime, userid)
         unlock
         self:LogChanges(old_rec, txdate, txtime, ingdat)
      endif
      self:userid := userid
      self:txdate := txdate
      self:txtime := txtime
   endif
endif
use
select(old)
return(aBrokenRules)

Method Equals(old_rec) class Process
local retval := .T.
   set exact on
   if self:nameProcess != old_rec:nameProcess
      retval := .F.
   endif
   if self:codeProcess != old_rec:codeProcess
      retval := .F.
   endif
   if self:idApplication != old_rec:idApplication
      retval := .F.
   endif
   if self:deleted != old_rec:deleted
      retval := .F.
   endif
   set exact off
return(retval)
 
Method Transfer() class Process
   self:id := proc->ID 	
   self:nameProcess := rtrim(proc->PROCOMS)
   self:codeProcess := rtrim(proc->PROCCODE)
   self:idApplication := proc->APPLID
   self:deleted := proc->DELETED 	
   self:userid := proc->USERID 	
   self:txdate := proc->TXDATE 	
   self:txtime := proc->TXTIME 	
return(self)

Method Replace(txdate, txtime, userid) class Process
   proc->PROCOMS := self:nameProcess
   proc->PROCCODE := self:codeProcess
   proc->APPLID := self:idApplication
   proc->DELETED := self:deleted
   proc->USERID := userid
   proc->TXDATE := txdate
   proc->TXTIME := txtime
return(nil)

Method LogChanges(old_rec, txdate, txtime, ingdat) class Process
   if self:nameProcess != old_rec:nameProcess
      DbfLogAdd(alias(), "PROCOMS", old_rec:id, old_rec:nameProcess, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:codeProcess != old_rec:codeProcess
      DbfLogAdd(alias(), "PROCCODE", old_rec:id, old_rec:codeProcess, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:idApplication != old_rec:idApplication
      DbfLogAdd(alias(), "APPLID", old_rec:id, str(old_rec:idApplication), old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:deleted != old_rec:deleted
      DbfLogAdd(alias(), "DELETED", old_rec:id, old_rec:deleted, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
return(nil)

// put here your udf's

/* BEGIN */
Method GetProcessId(sProcoms) class Processes
   local old := select(), retval := 0
   select 0
   use proc 
   do while .not. eof() 
      if proc->PROCOMS = sProcoms 
         retval := proc->ID
         exit
      endif
      skip
   enddo
   use
   select(old)
return(retval)
/* END */
