/*
   This source code has been generated with HMGGEN - Harbour Application Generator.
   Please do not remove the BEGIN and END tags and place your own code between the 
   predefined BEGIN and END tags.	
*/

#include <hmg.ch>
#include "hbclass.ch"
/* BEGIN */
/* END */

class Users
   Method Init() constructor
   Method Find(userid, users, refdat)
   Method Get(id, user, requestor, refdat)
   /* BEGIN */
   Method QueryAll()
   Method QueryOnUserid(userid, user)
   /* END */
endclass   

Method Init() class Users
return self

Method Find(userid, users, refdat) class Users
   local old := select(), obj := {}
   select 0
   use user index usera 
   /* BEGIN */
   /* END */	
   if pcount() < 3 .or. empty(refdat)
      seek str(userid, 10)
      do while .not. eof() .and. user->USERID = userid
         aadd(users, User():New():Transfer()) 
         skip
      enddo
   else
      // time travelling
      set deleted off
      seek str(userid, 10)
      do while .not. eof() .and. user->USERID = userid
         obj := SaveRec(obj)
         DbfLogRollback("USER", user->ID, refdat)
         if user->DELETED == "N" .and. user->INGDAT <= refdat 
            aadd(users, User():New():Transfer()) 
         endif
         RestRec(obj)
         skip
      enddo
      set deleted on
   endif
   use
   select(old)
return users
   
Method Get(id, user, requestor, refdat) class Users
   local old := select(), n, obj := {}
   if requestor != "old"
      select 0
      use USER index USER
   endif
   seek str(id, 10)
   if found()
      if pcount() > 3 .and. !empty(refdat)
         obj := SaveRec(obj)
         DbfLogRollback("USER", user->ID, refdat)
         user:Transfer()	
         RestRec(obj)
      else
         user:Transfer()	
      endif
   endif
   if requestor != "old" 
      /* BEGIN */
      /* END */
      use
   endif  
   select(old)
return user

class User
   data id
   data codeUserGroup
   data valueAuthorization
   data nameUser
   data codePassword
   data nameOrganisationUnit
   data codeCountry
   data numberMobile
   data descrEmail
   data descrWebsite
   data numberUser
   data deleted
   data userid
   data txdate     
   data txtime
   Method Init() constructor
   Method Save(txdate, txtime, userid, ingdat)
   Method Equals(old) protected
   Method Transfer()
   Method Replace(txdate, txtime, userid) protected
   Method LogChanges(old_rec, txdate, txtime, ingdat) protected
   /* BEGIN */
   /* END */
endclass

Method Init() class User
   self:id := 0
   self:codeUserGroup := ""
   self:valueAuthorization := 0
   self:nameUser := ""
   self:codePassword := ""
   self:nameOrganisationUnit := ""
   self:codeCountry := ""
   self:numberMobile := ""
   self:descrEmail := ""
   self:descrWebsite := ""
   self:numberUser := 0
   self:deleted := "N"
   self:userid := ""
   self:txdate := ctod(" -  -    ")     
   self:txtime := ""
   /* BEGIN */
   /* END */
return self

Method Save(txdate, txtime, userid, ingdat) 
local id, newId, bChanged, old_rec, old := select(), aBrokenRules := {}
select 0
use user index user, usera
bChanged := .F.
id = self:id
if id <= 0
   // insert request
else
   // update or delete request
   old_rec = users():Get(id, user():New(), "old")
   if found()
      // check whether content has changed
      if self:Equals(old_rec)
         // do nothing
      else 
         // check concurrent update
         if self:txdate = old_rec:txdate .and. self:txtime = old_rec:txtime
            if self:deleted = "Y"
               RecLock(1)
               user->DELETED := self:deleted
               user->USERID := userid
               user->TXDATE := txdate
               user->TXTIME := txtime
               delete
               unlock
               self:LogChanges(old_rec, txdate, txtime, ingdat)
            else
               bChanged := .T.
            endif
         else 
            MsgInfo("record has been updated by: " + old_rec:userid)
         endif
      endif
   else
      // defensive programming
      MsgInfo("record deleted by other user")
   endif
endif
if id <= 0 .or. bChanged
   // evaluation of business rules, use aBrokenRules
   /* BEGIN */
   /* END */
   // end evaluation of business rules
   if empty(aBrokenRules)
      if id <= 0	
         newId = DbfGetID("USER")
         self:id = newId
         AddRec(1)	
         user->ID := self:id
         /* BEGIN */
         /* END */
         self:Replace(txdate, txtime, userid)
         unlock
      else
         RecLock(1)
         self:Replace(txdate, txtime, userid)
         unlock
         self:LogChanges(old_rec, txdate, txtime, ingdat)
      endif
      self:userid := userid
      self:txdate := txdate
      self:txtime := txtime
   endif
endif
use
select(old)
return(aBrokenRules)

Method Equals(old_rec) class User
local retval := .T.
   set exact on
   if self:codeUserGroup != old_rec:codeUserGroup
      retval := .F.
   endif
   if self:valueAuthorization != old_rec:valueAuthorization
      retval := .F.
   endif
   if self:nameUser != old_rec:nameUser
      retval := .F.
   endif
   if self:codePassword != old_rec:codePassword
      retval := .F.
   endif
   if self:nameOrganisationUnit != old_rec:nameOrganisationUnit
      retval := .F.
   endif
   if self:codeCountry != old_rec:codeCountry
      retval := .F.
   endif
   if self:numberMobile != old_rec:numberMobile
      retval := .F.
   endif
   if self:descrEmail != old_rec:descrEmail
      retval := .F.
   endif
   if self:descrWebsite != old_rec:descrWebsite
      retval := .F.
   endif
   if self:numberUser != old_rec:numberUser
      retval := .F.
   endif
   if self:deleted != old_rec:deleted
      retval := .F.
   endif
   set exact off
return(retval)
 
Method Transfer() class User
   self:id := user->ID 	
   self:codeUserGroup := rtrim(user->USERGRP)
   self:valueAuthorization := user->AUTHORNR
   self:nameUser := rtrim(user->NAME)
   self:codePassword := rtrim(user->PASSWORD)
   self:nameOrganisationUnit := rtrim(user->BO)
   self:codeCountry := rtrim(user->COUNTRY)
   self:numberMobile := rtrim(user->TELNR)
   self:descrEmail := rtrim(user->EMAIL)
   self:descrWebsite := rtrim(user->WEBSITE)
   self:numberUser := user->REFNR
   self:deleted := user->DELETED 	
   self:userid := user->USERID 	
   self:txdate := user->TXDATE 	
   self:txtime := user->TXTIME 	
return(self)

Method Replace(txdate, txtime, userid) class User
   user->USERGRP := self:codeUserGroup
   user->AUTHORNR := self:valueAuthorization
   user->NAME := self:nameUser
   user->PASSWORD := self:codePassword
   user->BO := self:nameOrganisationUnit
   user->COUNTRY := self:codeCountry
   user->TELNR := self:numberMobile
   user->EMAIL := self:descrEmail
   user->WEBSITE := self:descrWebsite
   user->REFNR := self:numberUser
   user->DELETED := self:deleted
   user->USERID := userid
   user->TXDATE := txdate
   user->TXTIME := txtime
return(nil)

Method LogChanges(old_rec, txdate, txtime, ingdat) class User
   if self:codeUserGroup != old_rec:codeUserGroup
      DbfLogAdd(alias(), "USERGRP", old_rec:id, old_rec:codeUserGroup, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:valueAuthorization != old_rec:valueAuthorization
      DbfLogAdd(alias(), "AUTHORNR", old_rec:id, str(old_rec:valueAuthorization), old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:nameUser != old_rec:nameUser
      DbfLogAdd(alias(), "NAME", old_rec:id, old_rec:nameUser, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:codePassword != old_rec:codePassword
      DbfLogAdd(alias(), "PASSWORD", old_rec:id, old_rec:codePassword, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:nameOrganisationUnit != old_rec:nameOrganisationUnit
      DbfLogAdd(alias(), "BO", old_rec:id, old_rec:nameOrganisationUnit, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:codeCountry != old_rec:codeCountry
      DbfLogAdd(alias(), "COUNTRY", old_rec:id, old_rec:codeCountry, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:numberMobile != old_rec:numberMobile
      DbfLogAdd(alias(), "TELNR", old_rec:id, old_rec:numberMobile, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:descrEmail != old_rec:descrEmail
      DbfLogAdd(alias(), "EMAIL", old_rec:id, old_rec:descrEmail, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:descrWebsite != old_rec:descrWebsite
      DbfLogAdd(alias(), "WEBSITE", old_rec:id, old_rec:descrWebsite, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:numberUser != old_rec:numberUser
      DbfLogAdd(alias(), "REFNR", old_rec:id, str(old_rec:numberUser), old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:deleted != old_rec:deleted
      DbfLogAdd(alias(), "DELETED", old_rec:id, old_rec:deleted, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
return(nil)

// put here your udf's

/* BEGIN */
Method QueryAll() class Users
   local old := select(), users := {}
   select 0
   use user index usera 
   do while .not. eof()
      aadd(users, User():New():Transfer()) 
      skip
   enddo
   use
   select(old)
return(users)

Method QueryOnUserid(userid, user) class Users
   local old := select()
   select 0
   use user index usera 
   seek padr(userid, 3)
   if found()
      user:Transfer()
   endif
   use
   select(old)
return(user)
/* END */
